routes/web.php
<?php

use App\Http\Controllers\Auth\AuthenticatedSessionController;
use App\Http\Controllers\Auth\RegisteredUserController;
use App\Http\Controllers\FilesController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/register', [RegisteredUserController::class, 'create'])
     ->middleware('guest')
     ->name('register');

Route::post('/register', [RegisteredUserController::class, 'store'])
     ->middleware('guest');

Route::get('/login', [AuthenticatedSessionController::class, 'create'])
     ->middleware('guest')
     ->name('login');

Route::post('/login', [AuthenticatedSessionController::class, 'store'])
     ->middleware('guest');

Route::get('/logout', [AuthenticatedSessionController::class, 'destroy'])
     ->middleware('auth')->name('logout');

Route::group(['middleware' => ['auth']], function(){
    Route::get('/', function(){
        return redirect(route('files.index'));
    });
    Route::apiResource('files', FilesController::class);
});

app/Models/File.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

/**
 * @property int $id
 * @property string $path
 * @property int $user_id
 * @property string $name
 * @property string $format
 * @property double $size
 */
class File extends Model
{
    use HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'user_id',
        'path',
        'name',
        'format',
        'size',
        'compressed',
    ];

	public static function createRules(): array {
        return [
            'file' => 'required|file|max:8192'
        ];
	}
	public static function editRules(): array {
        return [
            'name' => 'required|string',
        ];
	}

	public function user(): BelongsTo {
        return $this->belongsTo(User::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

/**
 * @property int $id
 * @property string $username
 */
class User extends Authenticatable
{
    use HasApiTokens, Notifiable, HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'username',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    public function setPasswordAttribute($value) {
        if($value) {
            $this->attributes['password'] = bcrypt($value);
        }
    }

    public function files(): HasMany {
        return $this->hasMany(File::class);
    }

    public static function registerRules(): array {
        return [
            'username' => 'required|string|unique:users,username',
            'password' => 'required|string|confirmed',
        ];
    }

    public static function loginRules(): array {
        return [
            'username' => 'required|string',
            'password' => 'required|string',
        ];
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests;
    use DispatchesJobs;
    use ValidatesRequests;
}

app/Http/Controllers/FilesController.php
<?php

namespace App\Http\Controllers;

use App\DataTables\FileDataTable;
use App\Http\Requests\FileRequest;
use App\Models\File;
use App\Repositories\FileRepository;
use Illuminate\Support\Facades\Storage;
use Laracasts\Flash\Flash;

class FilesController extends Controller
{
    public function __construct() {
        $this->authorizeResource(File::class);
    }

    public function index(FileDataTable $dataTable) {
        return $dataTable->render('files.index');
    }

    public function store(FileRequest $request) {
        FileRepository::store($request);
        Flash::success(__('Saved!'));
        return redirect(route('files.index'));
    }

    public function show(File $file) {
        return Storage::download($file->path, $file->name.'.zip');
    }

    public function update(FileRequest $request, File $file) {
        FileRepository::update($file, $request);
        Flash::success(__('Saved!'));
        return redirect(route('files.index'));
    }

    public function destroy(File $file) {
        FileRepository::destroy($file);
        Flash::success(__('Deleted!'));
        return redirect(route('files.index'));
    }
}

resources/views/files/datatables_actions.blade.php
@php($file = \App\Models\File::query()->find($id))

@if($file->compressed)
    @include('files.edit')

    <a href="{{route('files.show', $file)}}" class="btn btn-sm btn-secondary" download>
        <i class="fa fa-download"></i>
    </a>

    {!! Form::open(['route' => ['files.destroy', $file], 'method' => 'delete', 'style' => 'display: inline;']) !!}
    {!! Form::button('<i class="fa fa-trash"></i>', [
        'type' => 'submit',
        'class' => 'btn btn-danger btn-sm m-1 delete'
    ]) !!}
    {!! Form::close() !!}
@endif

resources/views/files/edit.blade.php
<button data-toggle="modal" data-target="#edit-file-modal-{{$file->id}}" class="btn btn-info btn-sm m-1">
    <i class="fa fa-edit"></i>
</button>
<div id="edit-file-modal-{{$file->id}}" data-backdrop="static" data-keyboard="false" class="modal" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-sm" role="document">
        <div class="modal-content">
            <h3 class="text-center mt-44">Change File Name</h3>
            <form action="{{ route('files.update', $file) }}" method="POST">
                @csrf
                @method('PUT')
                <div class="modal-body">
                    <input class="form-control" type="text" id="name" name="name" placeholder="Name" value="{{$file->name}}" style="width: 100%;" required>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-block ladda-button" data-style="expand-left" type="button" data-dismiss="modal">Close</button>
                    <button class="btn btn-success ladda-button" data-style="expand-left" type="submit">Update</button>
                </div>
            </form>
        </div>
    </div>
</div>

resources/views/files/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="content">
        <div class="card mb-4">
            <div class="card-body">
                <div class="card-title">
                    <h3 class="float-left">Files</h3>
                    @include('files.upload')
                </div>
                @include('layouts.datatable')
            </div>
        </div>
    </div>
@endsection

resources/views/files/upload.blade.php
<div class="float-right">
    <button data-toggle="modal" data-target="#upload-file-modal" class="btn btn-success">
        <i class="fa fa-plus"></i> Upload
    </button>
</div>
<div id="upload-file-modal" data-backdrop="static" data-keyboard="false" class="modal" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-sm" role="document">
        <div class="modal-content">
            <h3 class="text-center mt-44">Select file</h3>
            <form action="{{ route('files.store') }}" method="POST" enctype="multipart/form-data">
                @csrf
                <div class="modal-body">
                    <input class="form-control" name="file" id="file" type="file" required>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-block ladda-button" type="button" data-dismiss="modal">Close</button>
                    <button class="btn btn-success ladda-button" data-style="expand-left" type="submit">Upload</button>
                </div>
            </form>
        </div>
    </div>
</div>

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width,initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <link href="{{ asset('assets/vendor/bootstrap/bootstrap.min.css') }}" rel="stylesheet" />
        <link href="{{ asset('assets/vendor/perfect-scrollbar/perfect-scrollbar.min.css') }}" rel="stylesheet" />
        <link href="{{ asset('assets/vendor/sweetalert2/sweetalert2.min.css') }}" rel="stylesheet" />
        <link href="{{ asset('assets/vendor/ladda/ladda-themeless.min.css') }}" rel="stylesheet" />
        <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" />
        <link href="https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap.min.css" rel="stylesheet" />
        <link href="https://cdn.datatables.net/buttons/1.3.1/css/buttons.bootstrap.min.css" rel="stylesheet" />

        <link href="{{ asset('assets/css/theme.css') }}" rel="stylesheet" />
        <link href="{{ asset('assets/css/app.css') }}" rel="stylesheet" />

        @stack('styles')
    </head>
    <body class="text-left">

        <div class="app-admin-wrap layout-sidebar-large">
            @include('layouts.header')
            <div class="main-content-wrap d-flex flex-column">
                @include('flash::message')
                @yield('content')
            </div>
        </div>
        <div class="loadscreen">
            <div class="loader">
                <div class="loader-bubble loader-bubble-info d-block"></div>
            </div>
        </div>

        <script src="{{ asset('assets/vendor/jquery/jquery-3.3.1.min.js') }}"></script>
        <script src="{{ asset('assets/vendor/bootstrap/bootstrap.min.js') }}"></script>
        <script src="{{ asset('assets/vendor/perfect-scrollbar/perfect-scrollbar.min.js') }}"></script>
        <script src="{{ asset('assets/vendor/sweetalert2/sweetalert2.min.js') }}"></script>
        <script src="{{ asset('assets/vendor/ladda/spin.min.js') }}"></script>
        <script src="{{ asset('assets/vendor/ladda/ladda.min.js') }}"></script>

        <script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
        <script src="https://cdn.datatables.net/1.10.19/js/dataTables.bootstrap.min.js"></script>
        <script src="https://cdn.datatables.net/buttons/1.3.1/js/dataTables.buttons.min.js"></script>
        <script src="https://cdn.datatables.net/buttons/1.3.1/js/buttons.bootstrap.min.js"></script>
        <script src="https://cdn.datatables.net/buttons/1.3.1/js/buttons.colVis.min.js"></script>
        <script src="{{ asset('assets/vendor/datatables/buttons.server-side.js') }}"></script>

        <script src="{{ asset('assets/js/app.js') }}"></script>

        @stack('scripts')
    </body>
</html>

resources/views/layouts/datatable.blade.php
{!! $dataTable->table(['width' => '100%', 'class' => 'table table-striped table-bordered']) !!}

@push('scripts')
    {!! $dataTable->scripts() !!}
@endpush

resources/views/layouts/guest.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <meta name="csrf-token" content="{{ csrf_token() }}">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <link href="https://fonts.googleapis.com/css?family=Nunito:300,400,400i,600,700,800,900" rel="stylesheet">
    <link href="{{ asset('assets/css/theme.css') }}" rel="stylesheet" />
    <link href="{{ asset('assets/css/app.css') }}" rel="stylesheet" />

</head>
<body>
<div class="auth-layout-wrap" style="background-image: url({{ asset('assets/images/bg1.jpg') }})">
    <div class="auth-content">
        <div class="card o-hidden">
            <div class="row">
                @yield('content')
            </div>
        </div>
    </div>
</div>
</body>
</html>

resources/views/layouts/header.blade.php
<div class="app-admin-wrap layout-sidebar-large">
    <div class="main-header">
        <div class="logo-corner ml-48">
            <h5>Welcome <span class="username">{{ ucfirst(auth()->user()->username) }}</span>!</h5>
        </div>
        <div style="margin: auto"></div>
        <div class="header-part-right">
            <a class="mr-48" href="{{ route('logout') }}">
                <i class="i-Power-3 mr-1"></i> Logout
            </a>
        </div>
    </div>
</div>